/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 */

#include <dlfcn.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <string.h>

extern int Game_Main(const char *path, const char *udn);

typedef int (*MainFunc)(const char *, const char *);

int Game_Main(const char *path, const char *udn) {
	chdir(path);
	FILE *file;

	file = fopen("/dev/kmsg", "a+");
	fprintf (file, "Name %s Path %s \n",__FUNCTION__,path);

	void *dlHandle = dlopen("./main.so", RTLD_LAZY);
	if (!dlHandle) {
		return 1;
	}

	void *func = dlsym(dlHandle, "Main");
	if (!func) {
		dlclose(dlHandle);
		return 1;
	}
	assert(sizeof(MainFunc) == sizeof(func));
	MainFunc tmp;
	memcpy(&tmp, &func, sizeof(MainFunc));

	int res = tmp(path, udn);

	dlclose(dlHandle);

	return res;
}
